diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/Bmf.c olsrd-current/lib/bmf/src/Bmf.c
--- olsrd-0.5.0/lib/bmf/src/Bmf.c	2007-02-10 18:05:55.000000000 +0100
+++ olsrd-current/lib/bmf/src/Bmf.c	2007-04-22 19:40:38.000000000 +0200
@@ -1198,7 +1264,7 @@
  * Notes      : Another thread can gracefully stop this thread by sending
  *              a SIGALRM signal.
  * ------------------------------------------------------------------------- */
-static void* BmfRun(void* useless)
+static void* BmfRun(void* useless __attribute__((unused)))
 {
   /* Mask all signals except SIGALRM */
   sigset_t blockedSigs;
@@ -1206,7 +1272,7 @@
   sigdelset(&blockedSigs, SIGALRM);
   if (pthread_sigmask(SIG_BLOCK, &blockedSigs, NULL) != 0)
   {
-    olsr_printf(1, "%s: pthread_sigmask() error: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("pthread_sigmask() error");
   }
 
   /* Set up the signal handler for the process: use SIGALRM to terminate
@@ -1217,7 +1283,7 @@
    * function (see DoBmf()). */
   if (signal(SIGALRM, BmfSignalHandler) == SIG_ERR)
   {
-    olsr_printf(1, "%s: signal() error: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("signal() error");
   }
 
   /* Call the thread function until flagged to exit */
@@ -1292,9 +1358,23 @@
   BmfThreadRunning = 1;
   if (pthread_create(&BmfThread, NULL, BmfRun, NULL) != 0)
   {
-    olsr_printf(1, "%s: pthread_create error: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("pthread_create() error");
     return 0;
   }
+
+  if (EtherTunTapFd >= 0)
+  {
+    /* Deactivate IP spoof filter for EtherTunTap interface */
+    DeactivateSpoofFilter();
+
+    /* If the BMF network interface has a sensible IP address, it is a good idea
+     * to route all multicast traffic through that interface */
+    if (EtherTunTapIp != ETHERTUNTAPDEFAULTIP)
+    {
+      AddMulticastRoute();
+    }
+  }
+
   return 1;
 }
 
@@ -1306,24 +1386,33 @@
  * Return     : none
  * Data Used  : BmfThreadRunning, BmfThread
  * ------------------------------------------------------------------------- */
-void CloseBmf()
+void CloseBmf(void)
 {
+  if (EtherTunTapFd >= 0)
+  {
+    /* If there is a multicast route, try to delete it first */
+    DeleteMulticastRoute();
+
+    /* Restore IP spoof filter for EtherTunTap interface */
+    RestoreSpoofFilter();
+  }
+
   /* Signal BmfThread to exit */
-  if (pthread_kill(BmfThread, SIGALRM) != 0)
   /* Strangely enough, all running threads receive the SIGALRM signal. But only the
    * BMF thread is affected by this signal, having specified a handler for this
    * signal in its thread entry function BmfRun(...). */
+  if (pthread_kill(BmfThread, SIGALRM) != 0)
   {
-    olsr_printf(1, "%s: pthread_kill() error: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("pthread_kill() error");
   }
 
   /* Wait for BmfThread to acknowledge */
   if (pthread_join(BmfThread, NULL) != 0)
   {
-    olsr_printf(1, "%s: pthread_join() error: %s\n", PLUGIN_NAME, strerror(errno));
+    BmfPError("pthread_join() error");
   }
 
-  /* Time to clean up */
+  /* Clean up after the BmfThread has been killed */
   CloseBmfNetworkInterfaces();
 }
 
@@ -1366,7 +1455,12 @@
   {
     return SetCapturePacketsOnOlsrInterfaces(value);
   }
+  else if (strcmp(key, "BmfMechanism") == 0)
+  {
+    return SetBmfMechanism(value);
+  }
 
   /* Key not recognized */
   return 0;
 }
+
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/Bmf.h olsrd-current/lib/bmf/src/Bmf.h
--- olsrd-0.5.0/lib/bmf/src/Bmf.h	2007-02-10 18:05:55.000000000 +0100
+++ olsrd-current/lib/bmf/src/Bmf.h	2007-04-22 19:40:38.000000000 +0200
@@ -38,13 +38,12 @@
  * Description: Multicast forwarding functions
  * Created    : 29 Jun 2006
  *
- * $Id: Bmf.h,v 1.2 2007/02/10 17:05:55 bernd67 Exp $ 
  * ------------------------------------------------------------------------- */
 
 /* BMF plugin data */
 #define PLUGIN_NAME "OLSRD Basic Multicast Forwarding (BMF) plugin"
 #define PLUGIN_NAME_SHORT "OLSRD BMF"
-#define PLUGIN_VERSION "1.3 (" __DATE__ " " __TIME__ ")"
+#define PLUGIN_VERSION "1.4 (" __DATE__ " " __TIME__ ")"
 #define PLUGIN_COPYRIGHT "  (C) Thales Communications Huizen, Netherlands"
 #define PLUGIN_AUTHOR "  Erik Tromp (erik.tromp@nl.thalesgroup.com)"
 #define MOD_DESC PLUGIN_NAME " " PLUGIN_VERSION "\n" PLUGIN_COPYRIGHT "\n" PLUGIN_AUTHOR
@@ -52,8 +51,11 @@
 /* UDP-Port on which multicast packets are encapsulated */
 #define BMF_ENCAP_PORT 50698
 
+/* Forward declaration of OLSR interface type */
 struct interface;
 
+void BmfPError(char* format, ...) __attribute__((format(printf, 1, 2)));
+union olsr_ip_addr* MainAddressOf(union olsr_ip_addr* ip);
 int InterfaceChange(struct interface* interf, int action);
 int InitBmf(struct interface* skipThisIntf);
 void CloseBmf(void);
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/DropList.c olsrd-current/lib/bmf/src/DropList.c
--- olsrd-0.5.0/lib/bmf/src/DropList.c	2007-02-10 18:05:55.000000000 +0100
+++ olsrd-current/lib/bmf/src/DropList.c	2007-04-22 19:40:38.000000000 +0200
@@ -36,7 +36,6 @@
  *              and local broadcast packets are dropped.
  * Created    : 29 Jun 2006
  *
- * $Id: DropList.c,v 1.2 2007/02/10 17:05:55 bernd67 Exp $ 
  * ------------------------------------------------------------------------- */
 
 
@@ -44,7 +43,8 @@
 
 /* System includes */
 #include <assert.h> /* assert() */
-#include <stdio.h> /* NULL */
+#include <stddef.h> /* NULL */
+#include <stdio.h> /* sscanf */
 #include <stdlib.h> /* malloc */
 #include <string.h> /* memcmp */
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/DropList.h olsrd-current/lib/bmf/src/DropList.h
--- olsrd-0.5.0/lib/bmf/src/DropList.h	2007-02-10 18:05:56.000000000 +0100
+++ olsrd-current/lib/bmf/src/DropList.h	2007-04-22 19:40:38.000000000 +0200
@@ -38,7 +38,6 @@
  * Description: List of MAC addresses of hosts from which all packets are dropped.
  * Created    : 29 Jun 2006
  *
- * $Id: DropList.h,v 1.2 2007/02/10 17:05:56 bernd67 Exp $ 
  * ------------------------------------------------------------------------- */
 
 struct TMacAddress
